/********************************************************************************
 *  Builder.h                                                                   *
 *                                                                              *
 *                                                                              *
 *  Petri Nets simulation program                                               *
 *  is written in C++  and it is a part of the PhD research of                  *
 *  Polina Reshetova performed in 2010-2014 at                                  *
 *  Biosystems data analysis group, SILS,                                       *
 *  University van Amsterdam                                                    *
 *                                                                              *
 *  Written by Polina Reshetova                                                 *
 *                                                                              *
 *                                                                              *
 *  This is free software: you can redistribute it and/or modify                *
 *  it under the terms of the GNU Lesser General Public License as published by *
 *  the Free Software Foundation, either version 3 of the License, or           *
 *  (at your option) any later version.                                         *
 *                                                                              *
 *  the software is distributed in the hope that it will be useful,             *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *  GNU Lesser General Public License for more details.                         *
 *                                                                              *
 *  You should have received a copy of the GNU Lesser General Public License    *
 *  along with this software.  If not, see <http://www.gnu.org/licenses/>.      *
 ********************************************************************************/

#ifndef BUILDER_H_
#define BUILDER_H_

#include <iostream>
#include <string>
using std::iostream;
using std::string;

#include <libxml++/libxml++.h>

#include "../Exception.h"

#include "../net/Net.h"
#include "../Randomizer.h"


class Builder {
private:
	//DOMDocument* parse(string inFile);
	xmlpp::Document* parse(string inFile);
	Place* handle_place(const xmlpp::Node*);
	Transition* handle_transition(const xmlpp::Node*);

public:
	Builder();
	virtual ~Builder();

	Net* buildNet(string filename, Randomizer *randomizer);
	Transition *parseReaction(xmlpp::NodeSet::iterator iter, Net* net);
};

#endif /* BUILDER_H_ */
