/********************************************************************************
 *  TBlock.h                                                                    *
 *                                                                              *
 *                                                                              *
 *  Petri Nets simulation program                                               *
 *  is written in C++  and it is a part of the PhD research of                  *
 *  Polina Reshetova performed in 2010-2014 at                                  *
 *  Biosystems data analysis group, SILS,                                       *
 *  University van Amsterdam                                                    *
 *                                                                              *
 *  Written by Polina Reshetova                                                 *
 *                                                                              *
 *                                                                              *
 *  This is free software: you can redistribute it and/or modify                *
 *  it under the terms of the GNU Lesser General Public License as published by *
 *  the Free Software Foundation, either version 3 of the License, or           *
 *  (at your option) any later version.                                         *
 *                                                                              *
 *  the software is distributed in the hope that it will be useful,             *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *  GNU Lesser General Public License for more details.                         *
 *                                                                              *
 *  You should have received a copy of the GNU Lesser General Public License    *
 *  along with this software.  If not, see <http://www.gnu.org/licenses/>.      *
 ********************************************************************************/


#ifndef TBLOCK_H_
#define TBLOCK_H_

#include <vector>
#include "Transition.h"
#include "stdlib.h"
#include "../Randomizer.h"

class TBlock {
protected:
	vector<Transition*> transitions;
	Randomizer * randomizer;
	std::string name;
	std::string *id;
public:
	TBlock(Randomizer * r);
	virtual ~TBlock();

	std::string getName() const;
	void setName(std::string name);

    std::string *getId() const;
    bool add(Transition *t);
    Transition *findTransitionByName(const std::string& name);

    vector<Transition*> *getTransitions();
    int getMaximumTokensNumber();

	bool isEnabled() const;
	void fire();
};

#endif /* TBLOCK_H_ */
