/********************************************************************************
 *                                                                              *
 *  Profiler.h                                                                  *
 *                                                                              *
 *                                                                              *
 *  Petri Nets simulation program                                               *
 *  is written in C++  and it is a part of the PhD research of                  *
 *  Polina Reshetova performed in 2010-2014 at                                  *
 *  Biosystems data analysis group, SILS,                                       *
 *  University van Amsterdam                                                    *
 *                                                                              *
 *  Written by Polina Reshetova                                                 *
 *                                                                              *
 *                                                                              *
 *  This is free software: you can redistribute it and/or modify                *
 *  it under the terms of the GNU Lesser General Public License as published by *
 *  the Free Software Foundation, either version 3 of the License, or           *
 *  (at your option) any later version.                                         *
 *                                                                              *
 *  the software is distributed in the hope that it will be useful,             *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *  GNU Lesser General Public License for more details.                         *
 *                                                                              *
 *  You should have received a copy of the GNU Lesser General Public License    *
 *  along with this software.  If not, see <http://www.gnu.org/licenses/>.      *
 ********************************************************************************/


#ifndef PROFILER_H_
#define PROFILER_H_

#include <vector>
#include "../net/Net.h"
#include <string.h>

#include <iostream>
#include <fstream>

using std::vector;

class Profiler {
private:
	Net * net;
private:
	vector<std::string> place_numbers;
	vector< vector <int> > concentrations;
public:
	Profiler(Net * net);
	virtual ~Profiler();

    virtual void record();

    virtual void printTokensProfiles(char* logFile);
    virtual void printAll(char *logFile);
    virtual void printTimeProfiles(int coeff, int i, char* logFile, std::vector<Place*> places);
    virtual void printFlowProfiles(Net* net, char* logFile);
};

#endif /* PROFILER_H_ */
