/********************************************************************************
 *  RunKeeper.cpp                                                               *
 *                                                                              *
 *                                                                              *
 *  Petri Nets simulation program                                               *
 *  is written in C++  and it is a part of the PhD research of                  *
 *  Polina Reshetova performed in 2010-2014 at                                  *
 *  Biosystems data analysis group, SILS,                                       *
 *  University van Amsterdam                                                    *
 *                                                                              *
 *  Written by Polina Reshetova                                                 *
 *                                                                              *
 *                                                                              *
 *  This is free software: you can redistribute it and/or modify                *
 *  it under the terms of the GNU Lesser General Public License as published by *
 *  the Free Software Foundation, either version 3 of the License, or           *
 *  (at your option) any later version.                                         *
 *                                                                              *
 *  the software is distributed in the hope that it will be useful,             *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *  GNU Lesser General Public License for more details.                         *
 *                                                                              *
 *  You should have received a copy of the GNU Lesser General Public License    *
 *  along with this software.  If not, see <http://www.gnu.org/licenses/>.      *
 ********************************************************************************/


#include "RunKeeper.h"

RunKeeper::RunKeeper() {
	// TODO Auto-generated constructor stub

}

RunKeeper::~RunKeeper() {
	// TODO Auto-generated destructor stub
}


void RunKeeper::save(std::string name, int tokens_number, int step_counter)
{

	if (keepers.size()<=step_counter)
	{
		StepKeeper *step_keeper = new StepKeeper();
		step_keeper->save(name,tokens_number);
		keepers.push_back(step_keeper);
	}else
	{
		keepers[step_counter]->save(name,tokens_number);
	}

	//std::cout << "step " << step_counter << " " << name << std::endl;
}

ShrinkedStep *RunKeeper::createShrinkedStep(int shrinked_coeff, std::vector<std::string> names)
{
	ShrinkedStep* shrinked_step = new ShrinkedStep();

	int step_in_tp = keepers.size() / shrinked_coeff;
	int size_of_shrink = shrinked_coeff+2;

	//std::cout << "names size " << names.size()<< std::endl;
	for(int j = 0; j < names.size(); j++)
	{
		std::vector <int> tokens (size_of_shrink,0);
		int step = 0;
		int tokens_sum = 0;
		//std::cout << "keepers size " << keepers.size() << std::endl;
		for(int i=0; i< keepers.size(); i++)
		{
			tokens_sum += keepers[i]->getTokensByName(names[j]);
		//	std::cout << "sum " << tokens_sum<< std::endl;
			if (i % step_in_tp == 0)
			{
				//save
				tokens[step] = tokens_sum;
				tokens_sum = 0;
				step++;
			}else if(i == (keepers.size()-1))
			{
				tokens[step] = tokens_sum;
			}
		}

		shrinked_step->add(names[j],tokens);
	}

	//shrinked_step->check();
	return shrinked_step;
}

void RunKeeper::check()
{
	std::cout << "size of step keepers " << keepers.size() << std::endl;

	for(int i=0; i < keepers.size(); i++)
	{
		keepers[i]->check();
	}
}
