/********************************************************************************
 *  ShrinkedStep.cpp                                                            *
 *                                                                              *
 *                                                                              *
 *  Petri Nets simulation program                                               *
 *  is written in C++  and it is a part of the PhD research of                  *
 *  Polina Reshetova performed in 2010-2014 at                                  *
 *  Biosystems data analysis group, SILS,                                       *
 *  University van Amsterdam                                                    *
 *                                                                              *
 *  Written by Polina Reshetova                                                 *
 *                                                                              *
 *                                                                              *
 *  This is free software: you can redistribute it and/or modify                *
 *  it under the terms of the GNU Lesser General Public License as published by *
 *  the Free Software Foundation, either version 3 of the License, or           *
 *  (at your option) any later version.                                         *
 *                                                                              *
 *  the software is distributed in the hope that it will be useful,             *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *  GNU Lesser General Public License for more details.                         *
 *                                                                              *
 *  You should have received a copy of the GNU Lesser General Public License    *
 *  along with this software.  If not, see <http://www.gnu.org/licenses/>.      *
 ********************************************************************************/



#include "ShrinkedStep.h"

ShrinkedStep::ShrinkedStep() {
	// TODO Auto-generated constructor stub

}

ShrinkedStep::~ShrinkedStep() {
	// TODO Auto-generated destructor stub
}


std::vector<int> ShrinkedStep::getTokensByPlaceId(std::string place_id)
{
	int number = getNumberByNameId(place_id);

//	if (place_id == "_2_4_hydroxy_phenyl_propionic_acid")
//	{
//		for(int i=0;i<tokens[number].size();i++)
//			std::cout <<tokens[number][i] <<" " ;
//
//			std::cout << " " << std::endl;
//	}
	return tokens[number];
}

void ShrinkedStep::add(std::string name, std::vector<int> tokens_number)
{
	names.push_back(name);
	tokens.push_back(tokens_number);
}


int ShrinkedStep::getNumberByNameId(std::string name_id)
{
	int number;
	for (int i = 0; i < names.size(); i++)
	{
		if (names[i] == name_id)
		{
			number = i;
		}
	}
	return number;
}

void ShrinkedStep::check()
{
	std::cout << "shrinked step names size " << names.size() << std::endl;
	std::cout << "shrinked step tokens size " << tokens.size() << std::endl;

	for (int i = 0; i < names.size(); i++)
	{
		std::cout << names[i] ;
		for (int j = 0; j < tokens[i].size(); j++)
		{
			std::cout << " " << tokens[i][j];
		}

		std::cout << " "  << std::endl;
	}
}
